package labss.lang.il.model.templates;

import labss.lang.il.model.LanguageEntity;

/**
 * @author Riccardo Solmi
 */
public class PrototypeFactory implements TemplateFactory {
	private LanguageEntity prototype;
	
	public PrototypeFactory(LanguageEntity prototype) {
		super();
		this.prototype = prototype;
	}
	
	public LanguageEntity create(Object... args) {
		return (LanguageEntity) prototype.clone();
	}

}
