package labss.lang.il.test;

import labss.lang.il.model.Expression;
import labss.lang.il.model.LanguageFactory;
import labss.lang.il.model.Statement;
import labss.lang.il.model.impl.ILLanguageFactory;

public class EsempioFattoriale {
	public static void main(String[] args) {
		LanguageFactory lf = ILLanguageFactory.instance();
		Expression result = lf.createVariable("result");
		Statement fatt = fact(lf, result);
		
		fatt.prettyPrint(System.out);
		fatt.execute();
		System.out.println("n! = " + result);
	}
	
	public static Statement fact(LanguageFactory lf, Expression result) {
		Expression n = lf.createVariable("n");
	    Statement fatt = lf.createBlock(new Statement[] {
			lf.createAssignment(n, lf.createLiteral(4)),
			lf.createAssignment(result, lf.createLiteral(1)),
		   	lf.createWhile(lf.createGreaterThan(n, lf.createLiteral(0)), lf.createBlock(new Statement[] {
	      		lf.createAssignment(result, lf.createMultiplication(result, n)),
	      		lf.createAssignment(n,lf.createSubtraction(n, lf.createLiteral(1)))
	    	}))
	    });
		return fatt;
	}
}
