package labss.lang.il.test;

import labss.lang.il.model.Expression;
import labss.lang.il.model.LanguageFactory;
import labss.lang.il.model.Statement;
import labss.lang.il.model.impl.ILLanguageFactory;
import labss.lang.il.model.templates.ILPrototypeManager;
import labss.lang.il.model.templates.PrototypeManager;

public class EsempioPrototypeManager {
	public static void main(String[] args) {
		PrototypeManager pm = ILPrototypeManager.instance();

		LanguageFactory lf = ILLanguageFactory.instance();

		Expression n = lf.createVariable("n");
		Expression result = lf.createVariable("result");
		pm.put("fatt", lf.createBlock(new Statement[] {
				lf.createAssignment(n, lf.createLiteral(4)),
				lf.createAssignment(result, lf.createLiteral(1)),
				lf.createWhile(lf.createGreaterThan(n, lf.createLiteral(0)), lf.createBlock(new Statement[] {
						lf.createAssignment(result, lf.createMultiplication(result, n)),
						lf.createAssignment(n,lf.createSubtraction(n, lf.createLiteral(1)))
				}))
		}));

		pm.create("while").prettyPrint(System.out);

		Statement fatt = (Statement) pm.create("fatt");
		fatt.prettyPrint(System.out);
//		fatt.execute();
	}
}
