package labss.lang.il.model.impl;

import labss.lang.il.model.Expression;
import labss.lang.il.model.Literal;

/**
 * @author Riccardo Solmi
 */
public abstract class AbstractIntegerBinaryExpression extends AbstractBinaryExpression {
	public AbstractIntegerBinaryExpression(Expression exp1, Expression exp2) {
		super(exp1, exp2);
	}

	/*
	 * Template Method
	 * @see unibo.cs.labss.editor.il.model.Expression#evaluate()
	 */
	public Literal evaluate() {
		return new IntegerLiteral(evaluate(exp1.evaluate().intValue(), exp2.evaluate().intValue()));
	}
	protected abstract int evaluate(int l1, int l2);
}
