package labss.lang.il.model.impl;

import labss.lang.il.model.LanguageEntity;

/**
 * @author Riccardo Solmi
 */
public abstract class AbstractLanguageEntity implements LanguageEntity {
	public Object clone() {
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			throw new InternalError();
		}
	}

	public LanguageEntity get(int index) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public void set(int index, LanguageEntity child) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public void add(LanguageEntity child) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public void add(int index, LanguageEntity child) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public LanguageEntity remove(int index) {
		throw new IllegalStateException("Illegal method call for this object");
	}

	public int size() {
		throw new IllegalStateException("Illegal method call for this object");
	}
}