package labss.lang.il.model.impl;

import labss.lang.il.model.*;

/**
 * @author Riccardo Solmi
 */
public class EqualsExpression extends AbstractBooleanIntegerBinaryExpression {
  public EqualsExpression(Expression exp1, Expression exp2) {
    super(exp1, exp2);
  }
	
  protected final String opStr() {
  	return " == ";
  }
  
  protected final boolean evaluate(int l1, int l2) {
	return l1 == l2;
  }
}