package labss.lang.il.model.impl;

import java.io.PrintStream;

import labss.lang.il.model.Expression;
import labss.lang.il.model.Literal;

/**
 * @author Riccardo Solmi
 */
public class NullExpression extends AbstractLanguageEntity implements Expression {
	public static final NullExpression instance = new NullExpression();
	private NullExpression() {
	}

	public Object clone() {
		return this;
	}

	public void prettyPrint(PrintStream out) {
		out.print("null");
	}

	public Literal evaluate() {
		throw new IllegalStateException("Illegal method call on a null object");
	}
}
