package labss.lang.il.model.impl;

import java.io.PrintStream;

import labss.lang.il.model.Statement;

/**
 * @author Riccardo Solmi
 */
public class NullStatement extends AbstractLanguageEntity implements Statement {
	public static final NullStatement instance = new NullStatement();
	private NullStatement() {
	}

	public Object clone() {
		return this;
	}

	public void prettyPrint(PrintStream out) {
		out.println(";");
	}

	public void execute() {
	}
}
